package com.coocaa.app.base;

import com.coocaa.app.Util.DateUtil;
import com.coocaa.app.Util.SparkUtils.;
import com.coocaa.app.base.dws_base_vid_rating..typecreator1.1;
import java.lang.invoke.SerializedLambda;
import java.util.Date;
import org.apache.spark.ml.feature.MinMaxScaler;
import org.apache.spark.ml.feature.MinMaxScalerModel;
import org.apache.spark.ml.feature.VectorAssembler;
import org.apache.spark.ml.linalg.Vector;
import org.apache.spark.sql.Column;
import org.apache.spark.sql.Dataset;
import org.apache.spark.sql.Row;
import org.apache.spark.sql.SaveMode;
import org.apache.spark.sql.SparkSession;
import org.apache.spark.sql.expressions.UserDefinedFunction;
import org.apache.spark.sql.expressions.WindowSpec;
import scala.Function1;
import scala.StringContext;
import scala.collection.Seq;
import scala.collection.SetLike;
import scala.collection.immutable.StringOps;
import scala.collection.immutable..colon.colon;
import scala.collection.mutable.ArrayOps.ofRef;
import scala.reflect.api.JavaUniverse;
import scala.reflect.api.Mirror;
import scala.reflect.api.TypeTags;
import scala.reflect.api.JavaUniverse.JavaMirror;
import scala.reflect.api.TypeTags.TypeTag;
import scala.runtime.BoxesRunTime;

public final class dws_base_vid_rating$ {

   public static dws_base_vid_rating$ MODULE$;


   static {
      new dws_base_vid_rating$();
   }

   public void main(String[] args) {
      SparkSession spark = .MODULE$.createSparkSession(this.getClass().getSimpleName());
      String day = spark.sparkContext().getConf().get("spark.input.date", DateUtil.getDateBeforeDay());
      String max_partition_candidate = com.coocaa.app.Util.FunctionsUtility..MODULE$.getMaxPartitionDaysFromHive(spark, "cayeneen_dws.dws_base_vid_mix_media_candidate_d");
      String max_partition_uv = com.coocaa.app.Util.FunctionsUtility..MODULE$.getMaxPartitionDaysFromHive(spark, "cayeneen_dws.dws_user_video_info_new");
      String max_partition_video = com.coocaa.app.Util.FunctionsUtility..MODULE$.getMaxPartitionDaysFromHive(spark, "cayeneen_ods.ods_cc_video_2018_partitions");
      String max_partition_money = com.coocaa.app.Util.FunctionsUtility..MODULE$.getMaxPartitionDaysFromHive(spark, "cayeneen_dws.dws_user_video_money_score");
      String max_partition_video_source = com.coocaa.app.Util.FunctionsUtility..MODULE$.getMaxPartitionDaysFromHive(spark, "cayeneen_ods.ods_cc_video_source_2018_partitions");
      String yesterday = spark.sparkContext().getConf().get("spark.input.date", DateUtil.getDateBeforeDay());
      String beforeDay_14 = DateUtil.getFormatDate(DateUtil.getDateBeforeOrAfter(DateUtil.getDateFromString(yesterday, "yyyy-MM-dd"), -15), "yyyy-MM-dd");
      String beforeDay_90 = DateUtil.getFormatDate(DateUtil.getDateBeforeOrAfter(DateUtil.getDateFromString(yesterday, "yyyy-MM-dd"), -90), "yyyy-MM-dd");
      String beforeDay_14_ = DateUtil.getFormatDate(DateUtil.getDateBeforeOrAfter(DateUtil.getDateFromString(yesterday, "yyyy-MM-dd"), -14), "yyyyMMdd");
      String beforeDay_7 = DateUtil.getFormatDate(DateUtil.getDateBeforeOrAfter(DateUtil.getDateFromString(yesterday, "yyyy-MM-dd"), -7), "yyyy-MM-dd");
      Date yesterday_ = DateUtil.getDateFromString(yesterday, "yyyyMMdd");
      UserDefinedFunction row_limit_year = org.apache.spark.sql.functions..MODULE$.udf(apply$mcFF$sp<invokedynamic>(), ((TypeTags)scala.reflect.runtime.package..MODULE$.universe()).TypeTag().Float(), ((TypeTags)scala.reflect.runtime.package..MODULE$.universe()).TypeTag().Float());
      Dataset didPlayInfo = spark.sql((new StringOps(scala.Predef..MODULE$.augmentString((new StringBuilder(219)).append("\r\n         |select coocaa_v_id, source as third_source, show_uv, click_uv ,\r\n         |play_uv, day_num, category_id, day_pay_arpu, day_pay_pv\r\n         |from cayeneen_dws.dws_user_video_info_new where dt=\'").append(max_partition_uv).append("\'\r\n         |").toString()))).stripMargin()).withColumn("play_uv", spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"play_uv"})))).$(scala.collection.immutable.Nil..MODULE$).cast("int")).withColumn("click_uv", spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"click_uv"})))).$(scala.collection.immutable.Nil..MODULE$).cast("int")).withColumn("show_uv", spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"show_uv"})))).$(scala.collection.immutable.Nil..MODULE$).cast("int")).withColumn("day_num", spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"day_num"})))).$(scala.collection.immutable.Nil..MODULE$).cast("int")).withColumn("category_id", spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"category_id"})))).$(scala.collection.immutable.Nil..MODULE$).cast("int")).withColumn("day_pay_arpu", spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"day_pay_arpu"})))).$(scala.collection.immutable.Nil..MODULE$).cast("float")).withColumn("day_pay_pv", spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"day_pay_pv"})))).$(scala.collection.immutable.Nil..MODULE$).cast("int")).persist(org.apache.spark.storage.StorageLevel..MODULE$.MEMORY_AND_DISK());
      Dataset maxPay = didPlayInfo.groupBy("third_source", scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"category_id"}))).agg(org.apache.spark.sql.functions..MODULE$.max(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"day_pay_pv"})))).$(scala.collection.immutable.Nil..MODULE$)).as("day_pay_pv"), scala.Predef..MODULE$.wrapRefArray((Object[])(new Column[0]))).filter(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"category_id"})))).$(scala.collection.immutable.Nil..MODULE$).$eq$eq$eq("1").or(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"category_id"})))).$(scala.collection.immutable.Nil..MODULE$).$eq$eq$eq("4"))).groupBy("third_source", scala.Predef..MODULE$.wrapRefArray((Object[])(new String[0]))).agg(org.apache.spark.sql.functions..MODULE$.min(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"day_pay_pv"})))).$(scala.collection.immutable.Nil..MODULE$)).as("max_pay"), scala.Predef..MODULE$.wrapRefArray((Object[])(new Column[0])));
      Dataset addMoneyValue = didPlayInfo.join(maxPay, (Seq)(new colon("third_source", scala.collection.immutable.Nil..MODULE$)), "inner").withColumn("add_money_value", org.apache.spark.sql.functions..MODULE$.when(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"category_id"})))).$(scala.collection.immutable.Nil..MODULE$).$eq$eq$eq("5").and(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"day_pay_pv"})))).$(scala.collection.immutable.Nil..MODULE$).$greater$eq(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"max_pay"})))).$(scala.collection.immutable.Nil..MODULE$).$times(BoxesRunTime.boxToDouble(0.3D)))), BoxesRunTime.boxToDouble(0.2D)).when(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"category_id"})))).$(scala.collection.immutable.Nil..MODULE$).$eq$eq$eq("5").and(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"day_pay_pv"})))).$(scala.collection.immutable.Nil..MODULE$).$greater$eq(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"max_pay"})))).$(scala.collection.immutable.Nil..MODULE$).$times(BoxesRunTime.boxToDouble(0.6D)))), BoxesRunTime.boxToDouble(0.4D)).when(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"category_id"})))).$(scala.collection.immutable.Nil..MODULE$).$eq$eq$eq("2").and(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"day_pay_pv"})))).$(scala.collection.immutable.Nil..MODULE$).$greater$eq(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"max_pay"})))).$(scala.collection.immutable.Nil..MODULE$).$times(BoxesRunTime.boxToDouble(0.4D)))), BoxesRunTime.boxToDouble(0.2D)).when(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"category_id"})))).$(scala.collection.immutable.Nil..MODULE$).$eq$eq$eq("2").and(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"day_pay_pv"})))).$(scala.collection.immutable.Nil..MODULE$).$greater$eq(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"max_pay"})))).$(scala.collection.immutable.Nil..MODULE$).$times(BoxesRunTime.boxToDouble(0.8D)))), BoxesRunTime.boxToDouble(0.4D)).when(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"category_id"})))).$(scala.collection.immutable.Nil..MODULE$).$eq$eq$eq("9").and(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"day_pay_pv"})))).$(scala.collection.immutable.Nil..MODULE$).$greater$eq(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"max_pay"})))).$(scala.collection.immutable.Nil..MODULE$).$times(BoxesRunTime.boxToDouble(0.2D)))), BoxesRunTime.boxToDouble(0.25D)).when(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"category_id"})))).$(scala.collection.immutable.Nil..MODULE$).$eq$eq$eq("9").and(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"day_pay_pv"})))).$(scala.collection.immutable.Nil..MODULE$).$greater$eq(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"max_pay"})))).$(scala.collection.immutable.Nil..MODULE$).$times(BoxesRunTime.boxToDouble(0.7D)))), BoxesRunTime.boxToDouble(0.5D)).otherwise(BoxesRunTime.boxToInteger(0))).select("coocaa_v_id", scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"third_source", "add_money_value"})));
      Dataset vidStatus = spark.sql((new StringOps(scala.Predef..MODULE$.augmentString((new StringBuilder(628)).append("\r\n         |select distinct a.coocaa_v_id as coocaa_v_id, created_time, category_id, a.third_source as third_source from (\r\n         |select coocaa_v_id, created_time, third_source from cayeneen_ods.ods_cc_video_source_2018_partitions\r\n         |where dt=\'").append(max_partition_video_source).append("\' and status=1 and content_type=0 and created_time>\'").append(beforeDay_14).append("\')a\r\n         |inner join (\r\n         |    select coocaa_v_id, category_id, third_source from cayeneen_dws.dws_base_vid_mix_media_candidate_d\r\n         |where day=\'").append(max_partition_candidate).append("\' and category_id in (\'1\', \'2\', \'3\',\'4\', \'5\', \'9\')\r\n         |    )b\r\n         |on a.coocaa_v_id=b.coocaa_v_id and a.third_source=b.third_source\r\n         |").toString()))).stripMargin());
      Dataset vidStatusNew = vidStatus.filter("category_id in (\'1\', \'2\', \'3\', \'5\', \'9\')");
      Dataset vidNewIssue = vidStatus.filter("category_id=\'4\'").filter((new StringBuilder(15)).append("created_time>\'").append(beforeDay_7).append("\'").toString());
      Dataset upDating = spark.sql((new StringOps(scala.Predef..MODULE$.augmentString((new StringBuilder(369)).append("\r\n         |SELECT coocaa_v_id\r\n         |        from cayeneen_ods.ods_cc_video_source_2018_partitions\r\n         |        where dt=\'").append(max_partition_video_source).append("\'\r\n         |        and cast(updated_segment as int)<cast(publist_segment as int) and status=1\r\n         |          and third_source regexp \'yinhe|tencent|youku|mgtvsdk\' and cast(updated_segment as int)>0 and modify_time>\'").append(beforeDay_90).append("\'\r\n         |").toString()))).stripMargin());
      Seq vidUpdating = (Seq)((Row)upDating.select(scala.Predef..MODULE$.wrapRefArray((Object[])(new Column[]{org.apache.spark.sql.functions..MODULE$.collect_list("coocaa_v_id")}))).head()).getAs(0);
      Dataset vidDouban = spark.sql((new StringOps(scala.Predef..MODULE$.augmentString((new StringBuilder(990)).append("\r\n         |select a.coocaa_v_id coocaa_v_id,\r\n         |a.douban_score as douban_score,\r\n         |case\r\n         |  when a.year not in (\'null\', \'NULL\', \'\', \' \') then a.year\r\n         |  when a.year in (\'null\', \'NULL\', \'\', \' \') and a.release_time not in (\'null\', \'NULL\', \'\', \' \')\r\n         |      then YEAR(FROM_UNIXTIME(UNIX_TIMESTAMP(a.release_time,\'yyyyMMdd\')))\r\n         |  when a.year in (\'null\', \'NULL\', \'\', \' \') and a.issue_time not in (\'null\', \'NULL\', \'\', \' \')\r\n         |      then YEAR(FROM_UNIXTIME(UNIX_TIMESTAMP(a.issue_time,\'yyyyMMdd\')))\r\n         |           else a.year end as year\r\n         |from cayeneen_ods.ods_cc_video_2018_partitions a left join cayeneen_ods.ods_cc_video_source_2018_partitions b on a.coocaa_v_id = b.coocaa_v_id\r\n         |                where a.dt=\'").append(max_partition_video).append("\' and b.dt=\'").append(max_partition_video_source).append("\'\r\n         |                    and b.content_type = 0\r\n         |and a.status=1 and b.status=1 and a.category_id in (\'1\', \'2\', \'4\', \'5\', \'9\', \'3\') and title not like \'%测试%\'\r\n         |").toString()))).stripMargin()).withColumn("year", spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"year"})))).$(scala.collection.immutable.Nil..MODULE$).cast("int")).withColumn("year", row_limit_year.apply(scala.Predef..MODULE$.wrapRefArray((Object[])(new Column[]{spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"year"})))).$(scala.collection.immutable.Nil..MODULE$)})))).withColumn("year_score", spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"year"})))).$(scala.collection.immutable.Nil..MODULE$).$minus(org.apache.spark.sql.functions..MODULE$.lit(BoxesRunTime.boxToInteger(2000)))).groupBy("coocaa_v_id", scala.Predef..MODULE$.wrapRefArray((Object[])(new String[0]))).agg(org.apache.spark.sql.functions..MODULE$.min(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"year_score"})))).$(scala.collection.immutable.Nil..MODULE$)).as("year_score"), scala.Predef..MODULE$.wrapRefArray((Object[])(new Column[0])));
      Dataset vidTagFilm = spark.sql((new StringOps(scala.Predef..MODULE$.augmentString((new StringBuilder(308)).append("\r\n         |select coocaa_v_id, third_source, tag_code, tag_name, title, category_name, cast(category_id as int), hot\r\n         |from cayeneen_dws.dws_base_vid_mix_media_candidate_d\r\n         |              where day = \'").append(max_partition_candidate).append("\'\r\n         |              and category_id in (\'1\', \'2\', \'4\', \'5\', \'9\', \'3\')\r\n         |").toString()))).stripMargin()).na().fill(0L).withColumn("category_id", spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"category_id"})))).$(scala.collection.immutable.Nil..MODULE$).cast("int")).dropDuplicates("coocaa_v_id", scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"third_source"})));
      Dataset vidMoney = spark.sql((new StringOps(scala.Predef..MODULE$.augmentString((new StringBuilder(163)).append("\r\n         |select coocaa_v_id, source as third_source, cast(money_score as double)\r\n         |from cayeneen_dws.dws_user_video_money_score where dt=\'").append(max_partition_money).append("\'\r\n         |").toString()))).stripMargin()).withColumn("money_score", spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"money_score"})))).$(scala.collection.immutable.Nil..MODULE$).cast("double"));
      Dataset playScoreNum = vidTagFilm.join(didPlayInfo, (Seq)(new colon("coocaa_v_id", new colon("third_source", new colon("category_id", scala.collection.immutable.Nil..MODULE$)))), "left").join(vidDouban, (Seq)(new colon("coocaa_v_id", scala.collection.immutable.Nil..MODULE$)), "left").join(vidMoney, (Seq)(new colon("coocaa_v_id", new colon("third_source", scala.collection.immutable.Nil..MODULE$))), "left").join(addMoneyValue, (Seq)(new colon("coocaa_v_id", new colon("third_source", scala.collection.immutable.Nil..MODULE$))), "left").na().fill(0L).persist(org.apache.spark.storage.StorageLevel..MODULE$.MEMORY_AND_DISK());
      Dataset playScore_1 = this.diff_source_comp(spark, playScoreNum, 1, didPlayInfo, vidStatusNew, vidUpdating);
      Dataset playScore_2 = this.diff_source_comp(spark, playScoreNum, 2, didPlayInfo, vidStatusNew, vidUpdating);
      Dataset playScore_4 = this.diff_source_comp(spark, playScoreNum, 4, didPlayInfo, vidNewIssue, this.diff_source_comp$default$6());
      Dataset playScore_5 = this.diff_source_comp(spark, playScoreNum, 5, didPlayInfo, vidStatusNew, vidUpdating);
      Dataset playScore_9 = this.diff_source_comp(spark, playScoreNum, 9, didPlayInfo, vidStatusNew, this.diff_source_comp$default$6());
      Dataset playScore_3 = this.diff_source_comp(spark, playScoreNum, 3, didPlayInfo, vidStatusNew, this.diff_source_comp$default$6());
      Dataset playScoreResult = playScore_1.union(playScore_2).union(playScore_4).union(playScore_5).union(playScore_9).union(playScore_3).dropDuplicates("coocaa_v_id", scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"third_source"})));
      playScoreResult.withColumn("day", org.apache.spark.sql.functions..MODULE$.lit(day)).write().mode(SaveMode.Overwrite).option("codec", "org.apache.hadoop.io.compress.SnappyCodec").insertInto("cayeneen_dws.dws_base_vid_rating_d_sc");
      spark.stop();
   }

   public Dataset diff_source_comp(SparkSession spark, Dataset playScoreNum, int category_id, Dataset didPlayInfo, Dataset vidStatusNew, Seq vidUpdating) {
      Dataset playScore_yd = this.getRating(spark, playScoreNum, category_id, didPlayInfo, vidStatusNew, vidUpdating, "snmyd");
      return playScore_yd;
   }

   public Seq diff_source_comp$default$6() {
      return (Seq)(new colon("0", scala.collection.immutable.Nil..MODULE$));
   }

   public Dataset getRating(SparkSession spark, Dataset playScoreNum, int category_id, Dataset didShowClickAll, Dataset vidStatusNew, Seq vidUpdating, String third_source) {
      byte S = 21;
      short A = 71;
      short B = 161;
      short C = 361;
      short filter_num = 500;
      if(category_id == 4) {
         S = 41;
         A = 141;
         B = 311;
         C = 701;
      }

      if(category_id == 0) {
         S = 51;
         A = 201;
         B = 451;
         C = 801;
      }

      if(category_id == 2) {
         S = 11;
         A = 31;
         B = 91;
         C = 161;
      }

      if(category_id == 30) {
         S = 16;
         A = 61;
         B = 181;
         C = 361;
      }

      if(((SetLike)scala.Predef..MODULE$.Set().apply(scala.Predef..MODULE$.wrapIntArray(new int[]{5, 11, 3, -2}))).contains(BoxesRunTime.boxToInteger(category_id))) {
         S = 11;
         A = 31;
         B = 61;
         C = 131;
         filter_num = 100;
      }

      if(((SetLike)scala.Predef..MODULE$.Set().apply(scala.Predef..MODULE$.wrapIntArray(new int[]{9, 34, 10, 22, 34, 40, -1}))).contains(BoxesRunTime.boxToInteger(category_id))) {
         S = 6;
         A = 21;
         B = 41;
         C = 101;
         filter_num = 100;
      }

      byte filter_grad_01 = 40;
      byte filter_grad_02 = 100;
      if(((SetLike)scala.Predef..MODULE$.Set().apply(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"tvb", "movie1905vip"})))).contains(third_source)) {
         filter_grad_01 = 5;
         filter_grad_02 = 15;
      }

      if(((SetLike)scala.Predef..MODULE$.Set().apply(scala.Predef..MODULE$.wrapIntArray(new int[]{5, 9}))).contains(BoxesRunTime.boxToInteger(category_id))) {
         filter_grad_01 = 10;
         filter_grad_02 = 30;
      }

      if(((SetLike)scala.Predef..MODULE$.Set().apply(scala.Predef..MODULE$.wrapIntArray(new int[]{34, 40}))).contains(BoxesRunTime.boxToInteger(category_id))) {
         filter_grad_01 = 1;
         filter_grad_02 = 3;
      }

      UserDefinedFunction row_limit_max = org.apache.spark.sql.functions..MODULE$.udf(apply$mcDF$sp<invokedynamic>(), ((TypeTags)scala.reflect.runtime.package..MODULE$.universe()).TypeTag().Double(), ((TypeTags)scala.reflect.runtime.package..MODULE$.universe()).TypeTag().Float());
      Dataset playScoreTemp = playScoreNum.filter(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"category_id"})))).$(scala.collection.immutable.Nil..MODULE$).$eq$eq$eq(BoxesRunTime.boxToInteger(category_id)).$amp$amp(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"third_source"})))).$(scala.collection.immutable.Nil..MODULE$).$eq$eq$eq(third_source)));
      if((new ofRef(scala.Predef..MODULE$.refArrayOps((Object[])playScoreTemp.collect()))).isEmpty()) {
         return playScoreTemp;
      } else {
         if(!((SetLike)scala.Predef..MODULE$.Set().apply(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"snmyd"})))).contains(third_source)) {
            Dataset didShowClick = didShowClickAll.filter(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"category_id"})))).$(scala.collection.immutable.Nil..MODULE$).$eq$eq$eq(BoxesRunTime.boxToInteger(category_id)).$amp$amp(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"third_source"})))).$(scala.collection.immutable.Nil..MODULE$).$eq$eq$eq(third_source))).filter(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"show_uv"})))).$(scala.collection.immutable.Nil..MODULE$).$greater(BoxesRunTime.boxToInteger(filter_num)));
            WindowSpec windowSpec = org.apache.spark.sql.expressions.Window..MODULE$.orderBy(scala.Predef..MODULE$.wrapRefArray((Object[])(new Column[]{spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"show_uv"})))).$(scala.collection.immutable.Nil..MODULE$).desc()})));
            Dataset dfWithRowNum = didShowClick.withColumn("row_num", org.apache.spark.sql.functions..MODULE$.row_number().over(windowSpec));
            Dataset filteredDFTop20 = dfWithRowNum.filter(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"row_num"})))).$(scala.collection.immutable.Nil..MODULE$).$less$eq(BoxesRunTime.boxToInteger(filter_grad_01)));
            Dataset filteredDF = dfWithRowNum.filter(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"row_num"})))).$(scala.collection.immutable.Nil..MODULE$).between(BoxesRunTime.boxToInteger(filter_grad_01), BoxesRunTime.boxToInteger(filter_grad_02)));
            Dataset filteredDFOther = dfWithRowNum.filter(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"row_num"})))).$(scala.collection.immutable.Nil..MODULE$).$greater(BoxesRunTime.boxToInteger(filter_grad_02)));
            long sumResultB = ((Row)filteredDF.agg(org.apache.spark.sql.functions..MODULE$.sum(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"show_uv"})))).$(scala.collection.immutable.Nil..MODULE$)), scala.Predef..MODULE$.wrapRefArray((Object[])(new Column[0]))).first()).getLong(0);
            long sumResultTop20 = ((Row)filteredDFTop20.agg(org.apache.spark.sql.functions..MODULE$.sum(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"show_uv"})))).$(scala.collection.immutable.Nil..MODULE$)), scala.Predef..MODULE$.wrapRefArray((Object[])(new Column[0]))).first()).getLong(0);
            long sumResultOther = ((Row)filteredDFOther.agg(org.apache.spark.sql.functions..MODULE$.sum(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"show_uv"})))).$(scala.collection.immutable.Nil..MODULE$)), scala.Predef..MODULE$.wrapRefArray((Object[])(new Column[0]))).first()).getLong(0);
            long sumVidOther = ((Row)filteredDFOther.agg(org.apache.spark.sql.functions..MODULE$.count(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"show_uv"})))).$(scala.collection.immutable.Nil..MODULE$)), scala.Predef..MODULE$.wrapRefArray((Object[])(new Column[0]))).first()).getLong(0);
            double avgShow = ((double)(sumResultTop20 * 2L + sumResultB) + (double)sumResultOther * 0.5D) / ((double)(filter_grad_01 * 2 + filter_grad_02 - filter_grad_01) + (double)sumVidOther * 0.5D);
            Dataset avgShowClick = didShowClick.withColumn("avg_score", org.apache.spark.sql.functions..MODULE$.lit(BoxesRunTime.boxToDouble(avgShow))).withColumn("min_show_d", org.apache.spark.sql.functions..MODULE$.when(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"show_uv"})))).$(scala.collection.immutable.Nil..MODULE$).$div(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"avg_score"})))).$(scala.collection.immutable.Nil..MODULE$)).$less(BoxesRunTime.boxToInteger(10)), spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"show_uv"})))).$(scala.collection.immutable.Nil..MODULE$).$div(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"avg_score"})))).$(scala.collection.immutable.Nil..MODULE$)).$times(BoxesRunTime.boxToDouble(0.2D))).otherwise(BoxesRunTime.boxToDouble(2.0D))).withColumn("min_show_d", org.apache.spark.sql.functions..MODULE$.lit(BoxesRunTime.boxToInteger(1)).$plus(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"min_show_d"})))).$(scala.collection.immutable.Nil..MODULE$))).withColumn("min_d_show", org.apache.spark.sql.functions..MODULE$.when(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"avg_score"})))).$(scala.collection.immutable.Nil..MODULE$).$div(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"show_uv"})))).$(scala.collection.immutable.Nil..MODULE$)).$less(BoxesRunTime.boxToInteger(10)), spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"avg_score"})))).$(scala.collection.immutable.Nil..MODULE$).$div(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"show_uv"})))).$(scala.collection.immutable.Nil..MODULE$)).$times(BoxesRunTime.boxToDouble(0.08D))).otherwise(BoxesRunTime.boxToDouble(0.8D))).withColumn("min_d_show", org.apache.spark.sql.functions..MODULE$.lit(BoxesRunTime.boxToInteger(1)).$minus(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"min_d_show"})))).$(scala.collection.immutable.Nil..MODULE$))).withColumn("ctr", row_limit_max.apply(scala.Predef..MODULE$.wrapRefArray((Object[])(new Column[]{spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"click_uv"})))).$(scala.collection.immutable.Nil..MODULE$).$div(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"show_uv"})))).$(scala.collection.immutable.Nil..MODULE$))})))).withColumn("ctr_score", org.apache.spark.sql.functions..MODULE$.when(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"show_uv"})))).$(scala.collection.immutable.Nil..MODULE$).$greater$eq(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"avg_score"})))).$(scala.collection.immutable.Nil..MODULE$)), spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"min_show_d"})))).$(scala.collection.immutable.Nil..MODULE$).$times(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"ctr"})))).$(scala.collection.immutable.Nil..MODULE$))).otherwise(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"min_d_show"})))).$(scala.collection.immutable.Nil..MODULE$).$times(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"ctr"})))).$(scala.collection.immutable.Nil..MODULE$)))).select("coocaa_v_id", scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"ctr_score"}))).na().fill(0L);
            playScoreTemp = playScoreTemp.join(avgShowClick, (Seq)(new colon("coocaa_v_id", scala.collection.immutable.Nil..MODULE$)), "left").withColumn("rank", org.apache.spark.sql.functions..MODULE$.row_number().over(org.apache.spark.sql.expressions.Window..MODULE$.orderBy(scala.Predef..MODULE$.wrapRefArray((Object[])(new Column[]{spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"play_uv"})))).$(scala.collection.immutable.Nil..MODULE$).desc()}))))).withColumn("play_uv_10", org.apache.spark.sql.functions..MODULE$.when(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"rank"})))).$(scala.collection.immutable.Nil..MODULE$).$less$eq(BoxesRunTime.boxToInteger(100)), spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"play_uv"})))).$(scala.collection.immutable.Nil..MODULE$)).otherwise(BoxesRunTime.boxToInteger(0))).withColumn("play_uv_other", org.apache.spark.sql.functions..MODULE$.when(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"rank"})))).$(scala.collection.immutable.Nil..MODULE$).$greater(BoxesRunTime.boxToInteger(100)), spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"play_uv"})))).$(scala.collection.immutable.Nil..MODULE$)).otherwise(BoxesRunTime.boxToInteger(0))).drop("rank").drop("play_uv").na().fill(0L);
         } else {
            playScoreTemp = playScoreTemp.withColumn("rank", org.apache.spark.sql.functions..MODULE$.row_number().over(org.apache.spark.sql.expressions.Window..MODULE$.orderBy(scala.Predef..MODULE$.wrapRefArray((Object[])(new Column[]{spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"play_uv"})))).$(scala.collection.immutable.Nil..MODULE$).desc()}))))).withColumn("play_uv_10", org.apache.spark.sql.functions..MODULE$.when(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"rank"})))).$(scala.collection.immutable.Nil..MODULE$).$less$eq(BoxesRunTime.boxToInteger(100)), spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"play_uv"})))).$(scala.collection.immutable.Nil..MODULE$)).otherwise(BoxesRunTime.boxToInteger(0))).withColumn("play_uv_other", org.apache.spark.sql.functions..MODULE$.when(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"rank"})))).$(scala.collection.immutable.Nil..MODULE$).$greater(BoxesRunTime.boxToInteger(100)), spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"play_uv"})))).$(scala.collection.immutable.Nil..MODULE$)).otherwise(BoxesRunTime.boxToInteger(0))).withColumn("ctr_score", org.apache.spark.sql.functions..MODULE$.lit(BoxesRunTime.boxToInteger(0))).drop("rank").drop("play_uv").na().fill(0L);
         }

         VectorAssembler assembler = (new VectorAssembler()).setInputCols((String[])((Object[])(new String[]{"play_uv_10", "hot", "day_num", "year_score", "ctr_score", "play_uv_other", "money_score", "day_pay_arpu"}))).setOutputCol("features");
         Dataset assembledData = assembler.transform(playScoreTemp);
         Function1 var10001 = apply<invokedynamic>();
         JavaUniverse $u = scala.reflect.runtime.package..MODULE$.universe();
         JavaMirror $m = scala.reflect.runtime.package..MODULE$.universe().runtimeMirror(this.getClass().getClassLoader());
         TypeTag var10002 = ((TypeTags)$u).TypeTag().apply((Mirror)$m, new 1());
         JavaUniverse $u1 = scala.reflect.runtime.package..MODULE$.universe();
         JavaMirror $m1 = scala.reflect.runtime.package..MODULE$.universe().runtimeMirror(this.getClass().getClassLoader());
         UserDefinedFunction getDoubleValues = org.apache.spark.sql.functions..MODULE$.udf(var10001, var10002, ((TypeTags)$u1).TypeTag().apply((Mirror)$m1, new com.coocaa.app.base.dws_base_vid_rating..typecreator2.1()));
         MinMaxScaler scaler = (new MinMaxScaler()).setInputCol("features").setOutputCol("norm_score").setMin(0.0D).setMax(1.0D);
         MinMaxScalerModel scalerModel = scaler.fit(assembledData);
         Dataset normalizedData = scalerModel.transform(assembledData);
         Dataset playScore = normalizedData.select("coocaa_v_id", scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"third_source", "title", "category_name", "norm_score", "tag_name", "add_money_value"}))).withColumn("norm_score", getDoubleValues.apply(scala.Predef..MODULE$.wrapRefArray((Object[])(new Column[]{spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"norm_score"})))).$(scala.collection.immutable.Nil..MODULE$)})))).withColumn("did_score_10", spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"norm_score"})))).$(scala.collection.immutable.Nil..MODULE$).getItem(BoxesRunTime.boxToInteger(0)).$times(BoxesRunTime.boxToDouble(0.3D))).withColumn("sub_did_score_10", spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"norm_score"})))).$(scala.collection.immutable.Nil..MODULE$).getItem(BoxesRunTime.boxToInteger(0)).$times(BoxesRunTime.boxToDouble(0.1D))).withColumn("hot", spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"norm_score"})))).$(scala.collection.immutable.Nil..MODULE$).getItem(BoxesRunTime.boxToInteger(1)).$times(BoxesRunTime.boxToDouble(0.5D))).withColumn("sub_hot_1", spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"norm_score"})))).$(scala.collection.immutable.Nil..MODULE$).getItem(BoxesRunTime.boxToInteger(1)).$times(BoxesRunTime.boxToDouble(0.4D))).withColumn("sub_hot_2", spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"norm_score"})))).$(scala.collection.immutable.Nil..MODULE$).getItem(BoxesRunTime.boxToInteger(1)).$times(BoxesRunTime.boxToDouble(0.3D))).withColumn("sub_hot_3", spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"norm_score"})))).$(scala.collection.immutable.Nil..MODULE$).getItem(BoxesRunTime.boxToInteger(1)).$times(BoxesRunTime.boxToDouble(0.2D))).withColumn("time_decay", spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"norm_score"})))).$(scala.collection.immutable.Nil..MODULE$).getItem(BoxesRunTime.boxToInteger(2)).$times(BoxesRunTime.boxToDouble(0.2D))).withColumn("year_score", spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"norm_score"})))).$(scala.collection.immutable.Nil..MODULE$).getItem(BoxesRunTime.boxToInteger(3)).$times(BoxesRunTime.boxToDouble(0.4D))).withColumn("ctr_score", spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"norm_score"})))).$(scala.collection.immutable.Nil..MODULE$).getItem(BoxesRunTime.boxToInteger(4)).$times(BoxesRunTime.boxToDouble(0.3D))).withColumn("ctr_score_other", spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"norm_score"})))).$(scala.collection.immutable.Nil..MODULE$).getItem(BoxesRunTime.boxToInteger(4)).$times(BoxesRunTime.boxToDouble(0.2D))).withColumn("did_score_other", spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"norm_score"})))).$(scala.collection.immutable.Nil..MODULE$).getItem(BoxesRunTime.boxToInteger(5)).$times(BoxesRunTime.boxToDouble(0.2D))).withColumn("sub_did_score_other", spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"norm_score"})))).$(scala.collection.immutable.Nil..MODULE$).getItem(BoxesRunTime.boxToInteger(5)).$times(BoxesRunTime.boxToDouble(0.1D))).withColumn("money_score", spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"norm_score"})))).$(scala.collection.immutable.Nil..MODULE$).getItem(BoxesRunTime.boxToInteger(6)).$times(BoxesRunTime.boxToDouble(0.7D))).withColumn("sub_money_score_1", spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"norm_score"})))).$(scala.collection.immutable.Nil..MODULE$).getItem(BoxesRunTime.boxToInteger(6)).$times(BoxesRunTime.boxToDouble(0.3D))).withColumn("sub_money_score_2", spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"norm_score"})))).$(scala.collection.immutable.Nil..MODULE$).getItem(BoxesRunTime.boxToInteger(6)).$times(BoxesRunTime.boxToDouble(0.2D))).withColumn("day_pay_arpu_score", spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"norm_score"})))).$(scala.collection.immutable.Nil..MODULE$).getItem(BoxesRunTime.boxToInteger(7)).$times(BoxesRunTime.boxToDouble(0.2D))).withColumn("day_pay_arpu_score", org.apache.spark.sql.functions..MODULE$.when(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"category_name"})))).$(scala.collection.immutable.Nil..MODULE$).isin((Seq)(new colon("电影", new colon("电视剧", new colon("综艺", new colon("动漫", new colon("Education", scala.collection.immutable.Nil..MODULE$))))))), spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"day_pay_arpu_score"})))).$(scala.collection.immutable.Nil..MODULE$)).otherwise(BoxesRunTime.boxToInteger(0))).withColumn("did_score_10", org.apache.spark.sql.functions..MODULE$.when(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"category_name"})))).$(scala.collection.immutable.Nil..MODULE$).isin((Seq)(new colon("电影", new colon("电视剧", new colon("综艺", new colon("动漫", scala.collection.immutable.Nil..MODULE$)))))), spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"did_score_10"})))).$(scala.collection.immutable.Nil..MODULE$)).otherwise(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"sub_did_score_10"})))).$(scala.collection.immutable.Nil..MODULE$))).withColumn("did_score_other", org.apache.spark.sql.functions..MODULE$.when(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"category_name"})))).$(scala.collection.immutable.Nil..MODULE$).isin((Seq)(new colon("电影", new colon("电视剧", new colon("动漫", scala.collection.immutable.Nil..MODULE$))))), spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"did_score_other"})))).$(scala.collection.immutable.Nil..MODULE$)).otherwise(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"sub_did_score_other"})))).$(scala.collection.immutable.Nil..MODULE$))).withColumn("money_score", org.apache.spark.sql.functions..MODULE$.when(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"category_name"})))).$(scala.collection.immutable.Nil..MODULE$).isin((Seq)(new colon("电影", new colon("电视剧", new colon("Education", scala.collection.immutable.Nil..MODULE$))))), spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"money_score"})))).$(scala.collection.immutable.Nil..MODULE$)).when(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"category_name"})))).$(scala.collection.immutable.Nil..MODULE$).isin((Seq)(new colon("综艺", new colon("动漫", scala.collection.immutable.Nil..MODULE$)))), spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"sub_money_score_1"})))).$(scala.collection.immutable.Nil..MODULE$)).otherwise(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"sub_money_score_2"})))).$(scala.collection.immutable.Nil..MODULE$))).withColumn("money_score", spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"money_score"})))).$(scala.collection.immutable.Nil..MODULE$).$plus(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"add_money_value"})))).$(scala.collection.immutable.Nil..MODULE$))).withColumn("ctr_score", org.apache.spark.sql.functions..MODULE$.when(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"category_name"})))).$(scala.collection.immutable.Nil..MODULE$).isin((Seq)(new colon("综艺", new colon("Education", scala.collection.immutable.Nil..MODULE$)))), spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"ctr_score_other"})))).$(scala.collection.immutable.Nil..MODULE$)).otherwise(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"ctr_score"})))).$(scala.collection.immutable.Nil..MODULE$))).withColumn("hot", org.apache.spark.sql.functions..MODULE$.when(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"category_name"})))).$(scala.collection.immutable.Nil..MODULE$).isin((Seq)(new colon("电影", new colon("电视剧", scala.collection.immutable.Nil..MODULE$)))), spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"hot"})))).$(scala.collection.immutable.Nil..MODULE$)).when(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"category_name"})))).$(scala.collection.immutable.Nil..MODULE$).isin((Seq)(new colon("纪录片", new colon("Education", scala.collection.immutable.Nil..MODULE$)))), spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"sub_hot_1"})))).$(scala.collection.immutable.Nil..MODULE$)).when(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"category_name"})))).$(scala.collection.immutable.Nil..MODULE$).isin((Seq)(new colon("综艺", new colon("动漫", scala.collection.immutable.Nil..MODULE$)))), spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"sub_hot_2"})))).$(scala.collection.immutable.Nil..MODULE$)).otherwise(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"sub_hot_3"})))).$(scala.collection.immutable.Nil..MODULE$))).withColumn("did_score", org.apache.spark.sql.functions..MODULE$.when(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"did_score_10"})))).$(scala.collection.immutable.Nil..MODULE$).$greater(BoxesRunTime.boxToInteger(0)).and(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"category_name"})))).$(scala.collection.immutable.Nil..MODULE$).isin((Seq)(new colon("电影", new colon("电视剧", new colon("动漫", scala.collection.immutable.Nil..MODULE$)))))), spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"did_score_10"})))).$(scala.collection.immutable.Nil..MODULE$).$plus(BoxesRunTime.boxToDouble(0.2D))).when(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"did_score_10"})))).$(scala.collection.immutable.Nil..MODULE$).$greater(BoxesRunTime.boxToInteger(0)).and(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"category_name"})))).$(scala.collection.immutable.Nil..MODULE$).$eq$eq$eq("综艺")), spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"did_score_10"})))).$(scala.collection.immutable.Nil..MODULE$).$plus(BoxesRunTime.boxToDouble(0.1D))).when(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"sub_did_score_10"})))).$(scala.collection.immutable.Nil..MODULE$).$greater(BoxesRunTime.boxToInteger(0)).and(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"category_name"})))).$(scala.collection.immutable.Nil..MODULE$).isin((Seq)(new colon("电影", new colon("电视剧", new colon("综艺", new colon("动漫", scala.collection.immutable.Nil..MODULE$)))))).unary_$bang()), spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"sub_did_score_10"})))).$(scala.collection.immutable.Nil..MODULE$).$plus(BoxesRunTime.boxToDouble(0.1D))).otherwise(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"did_score_other"})))).$(scala.collection.immutable.Nil..MODULE$))).withColumn("douban", org.apache.spark.sql.functions..MODULE$.lit(BoxesRunTime.boxToInteger(0))).withColumn("time_decay", org.apache.spark.sql.functions..MODULE$.when(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"category_name"})))).$(scala.collection.immutable.Nil..MODULE$).$eq$eq$eq("Education"), BoxesRunTime.boxToInteger(0)).otherwise(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"time_decay"})))).$(scala.collection.immutable.Nil..MODULE$))).withColumn("result", spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"did_score"})))).$(scala.collection.immutable.Nil..MODULE$).$plus(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"hot"})))).$(scala.collection.immutable.Nil..MODULE$)).$times(org.apache.spark.sql.functions..MODULE$.lit(BoxesRunTime.boxToInteger(1)).$minus(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"time_decay"})))).$(scala.collection.immutable.Nil..MODULE$))).$plus(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"douban"})))).$(scala.collection.immutable.Nil..MODULE$)).$plus(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"year_score"})))).$(scala.collection.immutable.Nil..MODULE$)).$plus(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"ctr_score"})))).$(scala.collection.immutable.Nil..MODULE$)).$plus(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"money_score"})))).$(scala.collection.immutable.Nil..MODULE$)).$plus(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"day_pay_arpu_score"})))).$(scala.collection.immutable.Nil..MODULE$)));
         return playScore.withColumn("temp", org.apache.spark.sql.functions..MODULE$.lit("default")).withColumn("rank", org.apache.spark.sql.functions..MODULE$.row_number().over(org.apache.spark.sql.expressions.Window..MODULE$.partitionBy("temp", scala.Predef..MODULE$.wrapRefArray((Object[])(new String[0]))).orderBy(scala.Predef..MODULE$.wrapRefArray((Object[])(new Column[]{org.apache.spark.sql.functions..MODULE$.desc("result")}))))).withColumn("rating", org.apache.spark.sql.functions..MODULE$.when(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"rank"})))).$(scala.collection.immutable.Nil..MODULE$).$less(BoxesRunTime.boxToInteger(S)), "S").when(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"rank"})))).$(scala.collection.immutable.Nil..MODULE$).$less(BoxesRunTime.boxToInteger(A)), "A").when(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"rank"})))).$(scala.collection.immutable.Nil..MODULE$).$less(BoxesRunTime.boxToInteger(B)), "B").when(spark.implicits().StringToColumn(new StringContext(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"rank"})))).$(scala.collection.immutable.Nil..MODULE$).$less(BoxesRunTime.boxToInteger(C)), "C").otherwise("D")).selectExpr(scala.Predef..MODULE$.wrapRefArray((Object[])(new String[]{"coocaa_v_id", "title", "result as score", "rating", "category_name as category", "did_score", "hot", "time_decay", "douban", "year_score", "ctr_score", "money_score", "third_source", "day_pay_arpu_score"})));
      }
   }

   public Seq getRating$default$6() {
      return (Seq)(new colon("0", scala.collection.immutable.Nil..MODULE$));
   }

   // $FF: synthetic method
   public static final float $anonfun$main$1(float x) {
      return (float)2000 > x?2000.0F:x;
   }

   // $FF: synthetic method
   public static final double $anonfun$getRating$1(float x) {
      return (double)x > 0.5D?0.5D:(double)x;
   }

   // $FF: synthetic method
   public static final double[] $anonfun$getRating$2(Vector vec) {
      return vec.toArray();
   }

   private dws_base_vid_rating$() {
      MODULE$ = this;
   }

   // $FF: synthetic method
   private static Object $deserializeLambda$(SerializedLambda var0) {
      return lambdaDeserialize<invokedynamic>(var0);
   }
}
